using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Cors;
using Microsoft.AspNetCore.Mvc;
using System;
using WK_KLI_LAPS_Service.App_Data;
using WK_KLI_LAPS_Service.Models.Master;

namespace WK_KLI_LAPS_Service.Controllers.Master.HeadingLevel
{
    [EnableCors("CorsPolicy")]
    [Authorize]
    [ApiController]
    [Route("api/[controller]")]
    public class HeadingLevelApiController : ControllerBase
    {
        CommonRepository oCommonRepository = new CommonRepository();

        private IHeadingLevelService _HeadingLevelservices;
        public HeadingLevelApiController(IHeadingLevelService HeadingLevelServices)
        {
            _HeadingLevelservices = HeadingLevelServices;

        }


        [Authorize]
        [HttpGet]
        //Code to retrieve all data
        public IActionResult GetAll()
        {
            var _list = _HeadingLevelservices.GetAll();
            return Ok(_list);
        }

        [Authorize]
        [HttpGet("GetActiveHeadingLevel")]
        //Code to retrieve active data
        public IActionResult GetActiveHeadingLevel()
        {
            var _list = _HeadingLevelservices.GetActiveHeadingLevel();
            return Ok(_list);
        }
        //Code to add new record
        [Authorize]
        [HttpPost("Add")]
        public IActionResult Add([FromBody] headinglevelModel oheadinglevelModel)
        {

            int retval = 0;
            try
            {
                retval = _HeadingLevelservices.Add(oheadinglevelModel);
                return Ok(retval);
            }
            catch (Exception ex)
            {
                oCommonRepository.ErrorLog(ex);
                // return error message if there was an exception
                return BadRequest(new { message = ex.Message });
            }

        }
        //Code to update specific record
        [Authorize]
        [HttpPost("Update")]
        public IActionResult Update([FromBody] headinglevelModel oheadinglevelModel)
        {
            int retval = 0;
            try
            {
                retval = _HeadingLevelservices.Edit(oheadinglevelModel);
                return Ok(retval);
            }
            catch (Exception ex)
            {
                oCommonRepository.ErrorLog(ex);
                // return error message if there was an exception
                return BadRequest(new { message = ex.Message });
            }

        }


        //Code to activate or deactivate specific record
        [Authorize]
        [HttpPost("activeordeactive")]
        public IActionResult Delete([FromBody] headinglevelModel oheadinglevelModel)
        {
            int retval = 0;
            try
            {
                retval = _HeadingLevelservices.Delete(oheadinglevelModel);
                return Ok(retval);
            }
            catch (Exception ex)
            {
                oCommonRepository.ErrorLog(ex);
                // return error message if there was an exception
                return BadRequest(new { message = ex.Message });
            }
        }
    }
}